<?php

/*

    Copyright (C) 2005 Zou Jie. All Rights Reserved.

    This file is part of WebDB. Designed and implemented by Zou Jie. Some 
    suggestions could be sent to jzou3700@gmail.com

    WebDB is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    WebDB is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with WebDB; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

include_once( "parse_tag.php" );

class url_parser extends parser {
	function url_parser($tag) {
		$this->sfs = "/:";

                if ( is_array($tag) )
                        $this->tag_tree =& $tag;
                else
                        $this->parse( $tag, $this->tag_tree );
	}
}

function url_parse( $url, &$server, &$port, &$file ) {
	$url_tree = new url_parser( $url );
	$port = 80;
	if ( $url_tree->tag_tree['/.3'][0] ) {
		$server = $url_tree->tag_tree['/.3'][0];
	}
	else {
		$server = $url_tree->tag_tree['/.3'][':.1'][0];
		$port =  $url_tree->tag_tree['/.3'][':.2'][0];
	}

	for( $i=4; $i<count($url_tree->tag_tree); $i++ ) {
		if ( $file )
			$file .= "/".$url_tree->tag_tree["/.$i"][0];
		else
			$file .= $url_tree->tag_tree["/.$i"][0];
	}
	if ( $file )
		$file .= "/".$url_tree->tag_tree['/.0'][0];
	else
		$file .= $url_tree->tag_tree['/.0'][0];
}

// url_parse( "http://www.sina.com.cn:80/index.html", $server, $port, $file );
// echo "http://$server:$port/$file";

// url_parse( "http://www.sina.com.cn/products/index.html", $server, $port, $file );
// echo "http://$server:$port/$file";

function getcontent($server, $port, $file)
{
   $proxy_server = "webcache.prc";
   $porxy_port = 8080;
   $cont = "";
   $ip = gethostbyname($proxy_server);
   $fp = fsockopen($ip, $porxy_port);
   // $ip = gethostbyname($server);
   // $fp = fsockopen($ip, $port);
   if (!$fp)
   {
       return "Unknown";


   }
   else
   {
       // $com = "GET http://$server/$file HTTP/1.1\r\nAccept: */*\r\nAccept-Language: de-ch\r\nAccept-Encoding: gzip, deflate\r\nUser-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)\r\nHost: $server:$port\r\nConnection: Keep-Alive\r\n\r\n";
       $com = "GET http://$server/$file HTTP/1.1\r\nAccept: */*\r\nAccept-Language: de-ch\r\nAccept-Encoding: deflate\r\nUser-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)\r\nHost: $server:$port\r\nConnection: Keep-Alive\r\n\r\n";
       fputs($fp, $com);
       while (!feof($fp))
       {
           $cont .= fread($fp, 500);
       }
       fclose($fp);
//echo $cont;
       $cont = substr($cont, strpos($cont, "\r\n\r\n") + 4);
       return $cont;
   }
}

function is_match( &$html, &$ptr, $tag ) {
	$html_cursor = substr( $html, $ptr, strlen($tag) );
	return strncasecmp($html_cursor, $tag, strlen($tag)) == 0;
}

function find_match( &$html, &$ptr, $tag ) {
	for( $i=0; $ptr<strlen($html); $i++, $ptr++ )  {
		if ( is_match($html, $ptr, $tag) ) {
			return;
		}
	}
}

function read_tag() {
global $html, $ptr;
global $content;

	for( 
		$content = null; $ptr<strlen($html);
		$ptr++ 
	) {
		//
		// filting comments remarked by <!-- -->
		//
/*
		if ( $html[$ptr] == "<" &&
			$html[$ptr+1] == "!" &&
			$html[$ptr+2] == "-" &&
			$html[$ptr+3] == "-" 
		) {
			$ptr += 4; 
			while( 
				!( $html[$ptr] == "-" &&  
				$html[$ptr + 1] == "-" &&  
				$html[$ptr + 2] == ">" ) 
			) {
				$ptr++;
			}
			$ptr += 3; 
			continue;
			
		}
*/
		$tag_script_begin = "<!--";
		$tag_script_end = "-->";
		while ( is_match( &$html, $ptr, $tag_script_begin) ) {
			$ptr += strlen( $tag_script_begin );
			find_match( &$html, &$ptr, $tag_script_end );
			$ptr += strlen( $tag_script_end );
		}


		//
		// filting scripts
		//
		$tag_script_begin = "<script";
		$tag_script_end = "</script>";
		while ( is_match( &$html, $ptr, $tag_script_begin) ) {
			$ptr += strlen( $tag_script_begin );
			find_match( &$html, &$ptr, $tag_script_end );
			$ptr += strlen( $tag_script_end );
		}

		if ( $html[$ptr] == "<" ) {
			$flag = true;
			$ptr++;
		}
		if ( $flag && $html[$ptr] == ">" ) {
			$flag = false;
			$ptr++;
			break;
		}

if (
			strcmp($html[$ptr],"\t")!=0 && 
			strcmp($html[$ptr],"\r")!=0 && 
			strcmp($html[$ptr],"\n")!=0 
)
		if ( $flag ) {
			$tag .= $html[$ptr];
		}
		else {
			$content .= $html[$ptr];
		}
	}

	return $tag;
}

//
// $tag = style ...>
// $curr_tag = /style
//
function tag_match( $tag, $curr_tag ) {
	$name_len = strlen($curr_tag) - 1;
	$curr_tag_name = substr($curr_tag, 1, 1+$name_len );
	$tag_name = substr($tag, 0, $name_len );
	return strncasecmp($curr_tag_name, $tag_name, strlen($tag_name))==0;
}

function indent( $t ) {
	for( $i=0; $i<$t; $i++ )
		echo " ";
}

$searched="table";

function matching_search_tag($tag) {
global $searched;
	return strncasecmp($tag, $searched, strlen($searched))==0;
}

function is_special_char( $char ) {
	return $char == "<" || $char == ">" || $char == "\n";
}

function is_anchor_tag( $tag  ) {
	$j=0;
	while( is_special_char($tag[$j]) ) $j++;
	if ( $tag[$j] == "a" && $tag[$j+1] == " " )
		return true;
	return false;
}

function is_table_tags( $tag  ) {
	$table_tags = array( 
		"table", "/table", "tbody", 
		"tr", "td", "/td", "/tr", "/tbody" 
	);
	
	foreach( $table_tags as $item ) {
		for( $i=0, $j=0; $i<strlen($item); $i++ ){
			if ( !is_special_char($item[$i]) ) {
				while( is_special_char($tag[$j]) ) $j++;
				if ( $tag[$j++] != $item[$i] )
					 break;
			}
		}
		if ( $i == strlen($item) )
			return true;
	}
// echo "return false\n";
	return false;
}

function display($fid, $id, $tag, $centent=null, $level) 
{
global	$layout;
	$output_links = false;


	if ( $fid )
		$full_id = $fid.$id;
	else
		$full_id = $id;

	//
	// Display a branch html tree.
	//
	$branch = $_REQUEST['branch'];
	if ( $branch ) {
global	$id_disp_flag;
		$id_disp_flag=false;
		if ( strncmp($full_id, $branch, strlen($branch)) == 0 )
			fmt_print($full_id, $tag, $centent=null, $level);
	}
	//
	// Display anchor only
	//
	else if ( $output_links ) {
		if ( is_anchor_tag($tag) ) {
			echo $tag."\n";
			fmt_print($full_id, $tag, $centent=null, $level);
		}
	}
	//
	// display table tag only.
	//
	else if ( $layout )  {
		if ( is_table_tags($tag) ) {
			fmt_print($full_id, $tag, $centent=null, $level);
		}
	}
	else {
		fmt_print($full_id, $tag, $centent=null, $level);
	}
}

function fmt_print($full_id, $tag, $centent=null, $level) 
{
global	$content;
global	$id_disp_flag;
global	$content_disp_flag;

	if ( $content && $content_disp_flag ) {
		echo indent( $level );
		echo "  $content\n";
	}


	if ( $id_disp_flag ) {
		echo "<a href=\"?url=".$_REQUEST['url']."&branch=$full_id\">";
		echo $full_id;
		echo "</a>";
		echo "  ";
	}
	else {
		echo indent( $level );
	}

global	$server;
	if ( $_REQUEST['branch'] ) {
		if ( strncmp($tag, "img", 3)==0 ) {
			revise_img_tag( "<$tag>", "http://".$server );
			// echo "$tag";
		}
		else {
			echo "<$tag>";
		}
	}
	else
		echo "$tag";
	echo "\n";
}

function html_tree($fid=null) {
static	$level=0; 
static	$curr_tag;
static  $foward_flag;
global	$id;

	// some tags without teminate remark. such as <p> <br>
	// These tags still be pushed into the stack. while </table> matched
	// it should be poped up from the stack.
	// 
	if ( $foward_flag ) return;	
	
	$curr_tag = $tag = read_tag();
	if ( $tag == null ) return; // End of the file
	if ( $tag[0] != "/" ) {

		display ( $fid, ++$id[$level], "$tag", $content, $level );
		$level++; 
		$id[$level]=0;
		if ( $fid ) 
			html_tree($fid.$id[$level-1].$tag[0].$tag[1]."_");
		else
			html_tree($id[$level-1].$tag[0].$tag[1]."_");
		$level--;

		if ( $curr_tag[0] == "/" && tag_match($tag, $curr_tag) ) {
			display ( $fid, $id[$level], "$curr_tag", null, $level );
			if ( $level == 0 ) return;
			$foward_flag = false;
			html_tree($fid);
		}
		else
			$foward_flag = true;
	}
	else {
		// if $tag[0] == "/" then return and pop the stack
	}

	if ( $fid==null ) {
		if ( $curr_tag )
			echo "$curr_tag";
	}
}

$id_disp_flag=true;
$content_disp_flag=false;
$content_disp_flag=true;
$layout=false;

/*
$ptr = 0; $id[0]=0;
$html = getcontent("cn.sun.com", 80, "index.html"); html_tree();
echo "-----------------------------------------------------------------\n\n";
$ptr = 0; $id[0]=0;
$html = getcontent("cn.sun.com", 80, "/products/"); html_tree();
echo "-----------------------------------------------------------------\n\n";
*/


$ptr = 0; $id[0]=0;
if ( !$_REQUEST['branch'] ) echo "<pre>";
// echo "<table><tbody>";
if ( $_REQUEST['url'] ) {
	url_parse( $_REQUEST['url'], $server, $port, $file );
	$html = &getcontent($server , $port, $file); 
// echo $html;
	html_tree();
}
else {
	$input = <<< EOD
<form enctype="multipart/form-data" action="html_process.php" method="post">
<input name="url" size="80">
<input type="submit" value="OK">
</form>

EOD;
	echo $input;
}

// echo "</tbody></table>";
if ( !$_REQUEST['branch'] ) echo "</pre>";

//
//
// http://redpanda.prc/cms/.conf/html_process.php?url=http://cn.sun.com/index.html&branch=1ht_2bo_1ta_1tr_2td_1di_1
//


?>

