<?php

/*

    Copyright (C) 2005 Zou Jie. All Rights Reserved.

    This file is part of WebDB. Designed and implemented by Zou Jie. Some 
    suggestions could be sent to jzou3700@gmail.com

    WebDB is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    WebDB is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with WebDB; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
$tag = <<< EOF
<img src="im/20050111.jpg" width="590" height="245" border="0" name="fimg" alt="Ч¸">
EOF;
*/

class parser {
	var $branch;
	var $sfs;
	var $tag_tree;

	function parser(&$tag, $sfs=null) {
		$this->branch = null;
		if ( $sfs )
			$this->sfs = $sfs;
		else
			$this->sfs = "<> =\"/";

		if ( is_array($tag) )
			$this->tag_tree =& $tag;
		else
			$this->parse( $tag, $this->tag_tree );
	}


	function parse( $tag, &$tag_tree, $level=0 ) {
		if ( 
			$this->sfs[$level] == null ||
			$tag == null 
		) {
			$tag_tree[] = $tag;
			return;
		}
		else {
			$tag_item = null; 
			$found=null;
			$counter=0;
			for( $i=0; $i<strlen($tag); $i++ ) {
				if ( $tag[$i] == $this->sfs[$level] ) {
					$found = $tag[$i];
					$counter++;
					// if ( strlen($tag_item)>0 ) 
					$this->parse( $tag_item, &$tag_tree["$found.$counter"], $level+1 );
					// $tag_tree[] = $tag[$i];
					$tag_item = null;
				}
				else
					$tag_item .= $tag[$i];
			}

			// if ( strlen($tag_item)>0 ) $counter++;
			//
			// we should parse the last substr
			//
			if ( $found ) {
				$this->parse( $tag_item, &$tag_tree["$found.0"], $level+1 );
			}
			else
				$this->parse( $tag_item, &$tag_tree, $level+1 );
		}
	}

	function get_pwd( $target, $path=null ){
		return $this->_get_pwd( &$this->tag_tree, $target );
	}

	var $found = false;
	function _get_pwd( &$tag_tree, $target, $path=null ){

		if ( $this->found ) return;
                foreach( $tag_tree as $key => $tag_item ) {
                        if ( is_array($tag_item) ) {
				if ( strcmp($target, $tag_item[0])==0 )  { 
					$found = true;
					$ret .= $path;
					return $ret;
				}
				$ret .= $this->_get_pwd( $tag_item, $target, $path."/".$key );
                        }
                }
		return $ret;

	}

	function set_branch( &$tag_tree ) {
		$this->branch = $tag_tree;
	}

	function branch_toString() {
		$this->toString( $this->branch );
	}

	function print_branch() {
		echo $this->branch_toString();
	}

	function get_branch( $target_path, &$branch ) {
		$this->_get_branch( $this->tag_tree, $target_path );
		$branch = new parser( $this->branch );
	}

	function _get_branch( &$t_tree, $target_path, $path=null ) {
	static	$finished = false;

                foreach( $t_tree as $key => $tag_item ) {
                        if ( is_array($tag_item) ) {
				$curr_path = "$path/$key";
				if ( 
					strlen($path) < strlen( $target_path ) 
				) {
					if ( strcmp($target_path, $curr_path)==0 ) {
						$this->branch = &$t_tree[$key];
						return $finished = true;
					}
					if ( 
						strncmp($target_path, $curr_path, strlen($curr_path))==0
					)  { 
						$this->_get_branch( &$t_tree[$key], $target_path, $curr_path );
						if ( $finished ) return $finished;
					}
				}

                        }
                }

		return $finished;
	}
	
	function getQuotation( $string ) {
		if ( 
			$string[0] == "\"" && 
			$string[strlen($string)-1] == "\"" 
		)
			return substr($string, 1,strlen($string)-2);
		else
			return $string;
	}

	function toString( $level=0 ) {
                foreach( $this->tag_tree as $key => $tag_item ) {
                        if ( is_array($tag_item) ) {
                                $ret .= $this->disp( $tag_item, $level+1 );
				if ( $key[2] != "0" ) $ret .= $key[0];
                        }
                        else
                                $ret .= $tag_item;
                }

		if ( $level == 0 )
			return $this->getQuotation($ret);
		else
			return $ret;
	}

	function disp( $tag_tree, $sfs=null, $level=0 ) {
                foreach( $tag_tree as $key => $tag_item ) {
                        if ( is_array($tag_item) ) {
                                $ret .= $this->disp( $tag_item, $level+1 );
				if ( $key[2] != "0" ) $ret .= $key[0];
                        }
                        else
                                $ret .= $tag_item;
                }

		return $ret;
	}

}

function revise_img_tag( $tag, $basedir ) {

	$img = new parser( $tag );
	$path = $img->get_pwd( "src" );
	//
	// key1=value1=value2=value3
	// =.1 => key1
	// =.2 => value1
	// =.3 => value2
	// =.0 => value3
	$img->get_branch( $path."/=.0", $img_src );

	$url_str = $img_src->toString();
	if ( strncmp($url_str, "http", 4)==0 ){
		// do nothing!
	}
	else {
		$href = "\"".$basedir.$url_str."\"";
		$src_new = new parser( $href );
		$img->set_branch( &$src_new->tag_tree );
	}
		
	echo $img->toString();
}

/*
$basedir = "http://cn.sun.com/";
revise_img_tag( $tag, $basedir );
*/

?>
